#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EventType {
    #[serde(rename = "INFO")]
    Info,
    #[serde(rename = "FLAG")]
    Flag,
    #[serde(rename = "ERROR")]
    Error,
    #[serde(rename = "SUCCESS")]
    Success,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EventType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EventType::Info => "INFO",
            EventType::Flag => "FLAG",
            EventType::Error => "ERROR",
            EventType::Success => "SUCCESS",
            EventType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EventType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EventType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EventType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<EventType, conjure_object::plain::ParseEnumError> {
        match v {
            "INFO" => Ok(EventType::Info),
            "FLAG" => Ok(EventType::Flag),
            "ERROR" => Ok(EventType::Error),
            "SUCCESS" => Ok(EventType::Success),
            v => v.parse().map(|v| EventType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EventType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<EventType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EventType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
